#ifndef _COOL_H_
#define _COOL_H_
/*  header file for ions  */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "constants.h"
#include "header.h"

#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 1
#endif

#define NTEMP	41  /*  "" ""  */
#define NTEMP1	11  /*  "" ""  */
#ifndef NIONS
#define NIONS   195
#endif
#define NION    181
#ifndef NUM
#define NUM     14
#endif
#define NUM1    13
#define NIONC	30
#define NCXH    8
#define NCXH1   9
#define NCXHE   7
#define NCXHE1  8
/*  global constants  */
#define TEP 2.302585
#define boltzk	1.38062e-16

/*  file paths  */
/* #define paste(front,back)       front ## back */

#define IONP	paste(HYDRODIR,"/dat/ion_pot.dat")
#define TABLE	paste(HYDRODIR,"/dat/tablesc93.dat")
#define ALION	paste(HYDRODIR,"/dat/alion.dat")
#define ALREC	paste(HYDRODIR,"/dat/alrec.dat")

/*  variables  */ 

int iH[NCXH1];
int iHe[NCXHE1];


static double Temp[NTEMP+1];
static double rion[NTEMP+1][NIONS+1];
static double rrec[NTEMP+1][NIONS+1];
static double cool[NTEMP+1][NIONS+1];
static double cxHr[NTEMP1+1][NIONS+1];
static double cxHer[NTEMP1+1][NIONS+1];
static double cxHi[NTEMP1+1][NCXH];
static double cxHei[NTEMP1+1][NCXHE];
static double pcl[NUM+1];

#endif
