      subroutine rs93_equil(T, dene)

      implicit none
      include 'jr_common.inc'

      real T, dene
      real Hneut, Hion
      real calc_rhy
      external calc_rhy

      rhy = calc_rhy(Hneut, Hion, T)
      call feline(T, dene, NUM, 0,0,0,0,0,1)

      return
      end

      subroutine rs93_nonequil(T, dene, dtime)

      implicit none
      include 'jr_common.inc'
      
      real T, dene, dtime
      integer no, nz, nz1, j
      integer icopy
      real Hneut, Hion
      real calc_rhy
      external calc_rhy, icopy

      rhy = calc_rhy(Hneut, Hion, T)

      do no=1,NUM
         nz = icopy(no)
         call nquil(T, nz, dene, 1, 0,0,1)
         call cycle(nz, dene, dtime)
         nz1 = nz + 1
         do j=1,nz1
            cnc(no,j) = conce(j)
         end do
      end do

      call feline(T, dene, NUM, 0,0,1,0,0,1)

      return
      end
      
      subroutine rs93_getdata(rs93_bin, rs93_brmev, rs93_recev,
     $     rs93_tufev, rs93_pc, rs93_cnc, rs93_power,
     $     rs93_nj, rs93_pcool, rs93_binmin, rs93_binsyz, rs93_Nbin)
      
      include 'jr_common.inc'
      integer i, j, indx
      integer rs93_Nbin, rs93_nj(NUM)
      real rs93_binmin, rs93_binsyz
      real rs93_pcool, rs93_pc(NUM), rs93_cnc(ALLION)
      real rs93_power(ALLION)
      real rs93_bin(MAXBINS), rs93_brmev(MAXBINS)
      real rs93_recev(MAXBINS),rs93_tufev(MAXBINS)
      
      rs93_pcool = pcool
      indx = 0
      do i=1,NUM
         rs93_nj(i) = nj(i)
         rs93_pc(i) = pc(i)
         do j=1,nj(i)+1
            rs93_cnc(indx+j) = cnc(i,j)
         end do
         indx = indx + nj(i)+1
      end do
      do i=1,ALLION 
         rs93_power(i) = power(i)
      end do
      rs93_Nbin = Nbin
      rs93_binmin = binmin
      rs93_binsyz = binsyz
      do i=1,nbin
         rs93_bin(i) = bin(i)
         rs93_brmev(i) = brmev(i)
         rs93_recev(i) = recev(i)
         rs93_tufev(i) = tufev(i)
      end do
      
      return
      end

      subroutine rs93_getlines(rs93_wavelen, rs93_fosc, rs93_linepwr,
     $     rs93_atom, rs93_ion, rs93_index, rs93_numlines)
      
      include 'jr_common.inc'
      integer i

      integer rs93_numlines
      integer rs93_atom(MAXLINES), rs93_ion(MAXLINES)
      integer rs93_index(MAXLINES)
      real rs93_wavelen(MAXLINES), rs93_linepwr(MAXLINES)
      real rs93_fosc(MAXBINS)

      rs93_numlines = numlines
      do i=1,numlines
         rs93_atom(i)   = nj(atom_index(i))
         rs93_ion(i)    = ion_index(i)
         rs93_index(i)  = line_index(i)
         rs93_wavelen(i)= wj(atom_index(i),line_index(i))
         rs93_fosc(i)   = fj(atom_index(i),line_index(i))
         rs93_linepwr(i)= pwr(atom_index(i),line_index(i))
      end do

      return
      end
