      subroutine cycle(n,dene,elapse)
C  jan-1981 version, copied from old jrfile.  commons changed
C  on 10/9/84 by Dick Edgar, to match 1984 version of JRFILE.
C
C  Aug 4 1986 - added timestep limit and iteration
C
      include 'jr_common.inc'
c      COMMON/RATES/C1(30),C2(30),CTH
c      COMMON/RESULT/CONCE(30),CA(30),POWER(220),RHY,HENEUT,HEPLUS,
c     1  DNE,PCOOL,POU,POT,RE,TU,PM(4)
      DIMENSION X(30),Y(30),ALF(30),BET(30),GAM(30)

      NN = N + 1
      fast = 0.
      do 10 j=1,nn
	if (conce(j) .lt. .0001) goto 10
	blatz = (c1(j) + c2(j))*dene
	if (blatz .gt. fast) fast = blatz
 10   continue
      jsubcy = 20.*fast*elapse
      if (jsubcy .eq. 0) jsubcy = 1
      if (jsubcy .gt. 100) jsubcy = 100
c     print 99,jsubcy
c99   format(' jsubcy =',i4)
c
      dt = dene*elapse/jsubcy
      do 500 jsub=1,jsubcy

      IF(N .NE. 1) GO TO 100
      CONCE(1) = ((1.+C2(2)*DT)*CONCE(1) + C2(2)*DT*CONCE(2))
     1  /(1.+(C1(1) + C2(2))*DT)
      CONCE(2) = 1. - CONCE(1)
      GO TO 400
  100 BOT = 1./(1.+C2(NN)*DT)
      X(N) = C1(N)*DT*BOT
      Y(N) = CONCE(NN)*BOT
      DO 200 K=2,N
        J = NN - K
        ALF(J+1) = -C2(J+2)*DT
        GAM(J+1) = -C1(J)*DT
        BET(J+1) = 1. + (C1(J+1) + C2(J+1))*DT
        BOT = 1./(ALF(J+1)*X(J+1) + BET(J+1))
        X(J) = -GAM(J+1)*BOT
        Y(J) = (CONCE(J+1) - ALF(J+1)*Y(J+1))*BOT
  200 CONTINUE
      ALF(1) = -C2(2)*DT
      BET(1) = 1. + C1(1)*DT
      CONCE(1) = (CONCE(1) - ALF(1)*Y(1))/(ALF(1)*X(1) + BET(1))
      DO 300 J=2,NN
        CONCE(J) = X(J-1)*CONCE(J-1) + Y(J-1)
  300 CONTINUE
  400 continue

  500 continue
      DO 450 J=1,NN
        CONCE(J) = AMAX1(0.,AMIN1(1.,CONCE(J)))
  450 CONTINUE
       RETURN
       END

      FUNCTION ICOPY(NO)

      include 'jr_common.inc'
c      COMMON/FEL/WJ(12,220),FJ(12,220),E3J(12,220),PWR(12,220), 
c     1  C1J(12,30),C2J(12,30),EJ(12,30),EAJ(12,30),S2J(12,30),
c     2  LLJ(12,30),S3J(12,30),S4J(12,30),S5J(12,30)
c      COMMON/DAT/E(30),EA(30),S2(30),WAVE(220),E3(220),F(220),LL(30), 
c     1  S3(30),S4(30),S5(30)
c      COMMON/PARAMS/NJ(12),ABUNJ(12),ABUND,BINMIN,BINSYZ,NBIN 
c      COMMON/RESULT/CONCE(30),CA(30),POWER(220),RHY,HENEUT,HEPLUS,
c     1  DNE,PCOOL,POU,POT,RE,TU,PM(4)
      COMMON/AUG/CAJ(12,30) 
c      COMMON/RATES/C1(30),C2(30),CTH
c      COMMON/COM/CNC(12,30),PTOT(12,220),ABIN(3000),BIN(3000) 
C     COMMON/CONTIN/BRMEV(3000),RECEV(3000),TUFEV(3000) 
C
      NLINES = 220
      ABUND = ABUNJ(NO) 
      DO 20 L = 1,NLINES
      WAVE(L) = WJ(NO,L)
      F(L) = FJ(NO,L) 
   20   E3(L) = E3J(NO,L)
      N = NJ(NO)
      DO 21 J=1,N 
      E(J) = EJ(NO,J) 
      EA(J) = EAJ(NO,J) 
      S2(J) = S2J(NO,J) 
      CONCE(J) = CNC(NO,J)
      LL(J) = LLJ(NO,J) 
      S3(J) = S3J(NO,J) 
      S4(J) = S4J(NO,J) 
   21   S5(J) = S5J(NO,J)
      E(N+1) = 0. 
      LL(N+1) = 0.
      CONCE(N+1) = CNC(NO,N+1)
C
      ICOPY=N 
      RETURN
      END 
C     SUBROUTINE PHOT 
C        DUMMY PHOTOIONIZATION ROUTINE
C     RETURN
C     END 
C     SUBROUTINE APHOT
C  ANOTHER DUMMY PHOT ROUTINE 
C     RETURN
C     END 
C 
C  HYDROGEN COOLING, VINTAGE FORTRAN II 
C   CRIBBED FROM 1981 VERSION OF JRFILE BY RJE
C 
      FUNCTION HCOOL1(T,RHY,ALTER)
C--------added 7/23/86 by RJE to allow partial cooling calculations.
      COMMON /PCL/ PC(12) ,pcj(30),pcnj(12,30),pch(2)
C ALTER=-1 IS CASE A (OPT THIN); 1 IS CASE B (OPT THICK LYMANN) 
      BETA = 157890./T
      IF(BETA - 0.5)10,10,20
   10 CHI = 1.2 * BETA + (0.55 + 1.04*ALOG(BETA)) * 
     1  BETA*BETA + (1.01*ALOG(BETA) - 0.43)* BETA**3 
      GO TO 30
   20 CHI = 0.5 * (0.735 + ALOG(BETA) + 1./(3.*BETA)) 
   30 ALFA = (2.07E-11)*(0.4288 + 0.5*ALOG(BETA) + 0.469/BETA**(.33333))
     1 /SQRT(T) 
      IF(ALTER)50,50,40
   40 CHI = CHI - P(BETA,1.)
      ALFA = ALFA - (2.07E-11)*(SEATON(BETA,1.))/SQRT(T)
C  WAS BETA*SEATON(BETA,1.).  FIXED 1/30/86 BY RJE
   50 CONTINUE
      C6 = (1.6027E-12)*13.6*(ALFA + 2.0*2.11E-22 *((3.14159*9.11E-28/
     1  (2.0 * (1.38E-16)*T))**(-.5) ) * CHI) * 1.0E23
      SUM = .416 * EXP(BETA/4.)/.75**(.62) +
     1   7.91E-2 * EXP(BETA/9.)/(8./9.)**(.62)  + 
     2   2.899E-2 * EXP(BETA/16.) /(15./16.)**(.62)  +
     3   1.394E-2 * EXP(BETA/25.)/(24./25.)**(.62)  + 
     4   7.799E-3 * EXP(BETA/36.)/(35./36.)**(.62)
      EXCITE = (1.6027E-12)*(1.0E23)*(4.6E-6)/(SQRT(13.6)*
     1    EXP(BETA) * BETA**(.12))*SUM
      BREMS=0.229*SQRT(T/1.0E6) 
C BREMS FORMULA FROM COX THESIS (P. 35) 
      pch(1)=excite
      pch(2)=(brems+c6)
C  partial cooling rates by ion added 7/23/87 by RJE
      HCOOL1 = (RHY * (BREMS + C6) + EXCITE)/(1.0 + RHY) 
      RETURN
      END
