      subroutine read_linelist(atom_index, ion_index, line_name,
     $     numlines)
c
c     Original version: Dick Edgar, UW, 1993?
c     read lines from the file atomic.dat
c
c     Rewritten as a subroutine by Randall Smith, 3/29/96
c
      implicit none

      integer MAXLINES 
      parameter(MAXLINES=2000)

      include 'jr_common.inc'
      include 'names.inc'

      integer numlines
      integer atom_index(MAXLINES), ion_index(MAXLINES)
      character*10 line_name(MAXLINES)
      integer i, k, index
      integer atom, ion_states, stage, ix, iy, iy3

      numlines = 0
      do atom=1,num
	ion_states = nj(atom)+1
	ix = 0
	do stage=1,ion_states
	  iy = llj(atom,stage)
	  iy3 = 3*iy
	  do k = 1,iy3
	    index = ix+k
	    if (wj(atom,index) .ne. 0.0) then
               numlines = numlines + 1
               atom_index(numlines) = atom
               ion_index(numlines)  = index
               write(line_name(numlines),FMT='(a2,2x,a6)')
     $              name(atom), roman(stage)
            end if
         end do
         ix = ix + iy3
       end do
      end do

      return
      end
